﻿using System;
using System.Collections.Generic;

namespace Consulenza.ReportCommon
{
    public class MonitoraggioImmobiliareNuclei
    {
        public Int64 ChiaveNucleo { get; set; }
        public string NomeNucleo { get; set; }
        public string AgenteNucleo { get; set; }
        public string ReteNucleo { get; set; }

        /// </summary>
        // public DateTime DtFineValidita { get; set; } viene usata per la query in cui dtFineValidita > getDate()
        public Int64 ChiaveClientePBPrincipale { get; set; }

        /// <summary>
        /// Lista di Id dell'immobile catastale per cui è richiesto il report.
        /// </summary>
        public List<string> IdImmobileCatasto { get; set; }
        //private List<string> _idImmobileCatasto = new List<string>();
        //public List<string> IdImmobileCatasto
        //{
        //    get { return _idImmobileCatasto; }
        //    set { _idImmobileCatasto = value; }
        //}
        /// <summary>
        /// Lista di ChiaviClientiPB per gli id dell'immobile catastale per cui è richiesto il report.(nel nucleo possono esserci più chiavicliente per idimmobile, per non avere schede immobile duplicate, aggiunta chiavecliente)
        /// </summary>
        private List<long> _chiaviClientiPBImmobili = new List<long>();
        public List<long> ChiaviClientiPBImmobili
        {
            get { return _chiaviClientiPBImmobili; }
            set { _chiaviClientiPBImmobili = value; }
        }
        /// <summary>
        /// Lista di Id delle sezioni (Schede) per cui è richiesto il report.
        /// </summary>
        private List<Int32> _idSezione = new List<Int32>();
        public List<Int32> IdSezione
        {
            get { return _idSezione; }
            set { _idSezione = value; }
        }

        private List<Cliente> _listaClientiNucleo = new List<Cliente>();
        public List<Cliente> ListaClientiNucleo
        {
            get { return _listaClientiNucleo; }
            set { _listaClientiNucleo = value; }
        }
        public bool ImmobiliareCEUnica { get; set; }
    }
}