﻿using Consulenza.ReportWriter.Business;
using Consulenza.ReportWriter.Business.OBJ_PDF;
using Consulenza.ReportWriter.Business.CUSTOM_PDF.ConsulenzaUnica;
using Consulenza.ReportCommon;
using Consulenza.ReportWriter.Manager.Integration;

namespace Consulenza.ReportWriter.Manager.Chapter.Unica
{
    /// <summary>
    /// S28.ProgettoUniversitaFigliDettaglioPortafoglioModello idcapitolo = 46
    /// </summary>
    public class S28 : Entity.Chapter
    {
        public string _nomeprogettoinvestimento = string.Empty;
        
        /// <summary>
        /// Costruttore
        /// </summary>
        /// <param name="environmentFacade"></param>
        /// <param name="idChapter"></param>
        public S28(EnvironmentFacade environmentFacade, int idChapter)
            : base(environmentFacade, idChapter)
        {
            Draw();
        }

        /// <summary>
        /// Costruttore
        /// </summary>
        /// <param name="environmentFacade"></param>
        /// <param name="idChapter"></param>
        /// <param name="repeatoneachpage"></param>
       
        public S28(EnvironmentFacade environmentFacade, int idChapter, bool repeatoneachpage)
            : base(environmentFacade, idChapter)
        {
            
            RepeatOnEachPage = repeatoneachpage;
            
        }

        protected override sealed void Draw()
        {         //Aggiungo la pagina
            //Aggiungo la pagina
            //AddElement(new PagePDF(PagePDF.PagePDFType.Generic));

            //var testi = GetText();

            //var intestazione = new ChapterHeadingPDF(
            //    string.Format(testi.Rows[0]["testo1"].ToString(), _nomeprogettoinvestimento),
                
            //    EnvironmentFacade.RendererFacade.XLeftLimit,
            //    EnvironmentFacade.RendererFacade.YUpperLimit,
            //    EnvironmentFacade.ReportEnvironment.FontFamily);

            //// Aggiungo gli elementi
            //AddElement(intestazione.ToElement());
        }
    }
}
