﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Newtonsoft.Json;
using System.Net;

namespace Consulenza.Web
{
    public partial class DatiSeiAnd : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            
        }
        protected void Button1_Click(object sender, EventArgs e)
        {
            testo.Text = "";
            string output = "";
            try
            {                 
                WSSEISVI.rsReportManager dati = reportManagerWSS();
                output = JsonConvert.SerializeObject(dati.responseData);
                holdtext.Text = output;
                output = output.Replace(",", ",<br />");
                //output = output.Replace("{", "<br />{<br />");
                output = output.Replace("{", "&nbsp;&nbsp;&nbsp;{<br />");
                output = output.Replace("}", "<br />}");  

            }
            catch (Exception ex)
            {
                output = ex.Message;
               
            }
            testo.Text = output;
             

           // var script = "window.open('about:blank').document.body.innerText +=JSON.stringify('" + output + "')";

            //var script = "var wnd = window.open(\"about:blank\", \"\", \"_blank\");wnd.document.write( \"prova\");";
           // ScriptManager.RegisterStartupScript(this, typeof(string), "OPEN_WINDOW", script, true);
        }

        protected void Button2_Click(object sender, EventArgs e)
        {
            testo.Text = "";
            string output = "";
            try
            {
                WSSEICOLL.rsReportManager dati = reportManagerWSC();
                output = JsonConvert.SerializeObject(dati.responseData);
                holdtext.Text = output;
                output = output.Replace(",", ",<br />");
                //output = output.Replace("{", "<br />{<br />");
                output = output.Replace("{", "&nbsp;&nbsp;&nbsp;{<br />");
                output = output.Replace("}", "<br />}");

            }
            catch (Exception ex)
            {
                output = ex.Message;

            }
            testo.Text = output;

            

        }


        protected void Button3_Click(object sender, EventArgs e)
        {
            testo.Text = "";
            string output = "";
            try
            {
                WSSEIPROD.rsReportManager dati = reportManagerWSP();
                output = JsonConvert.SerializeObject(dati.responseData);
                holdtext.Text = output;
                output = output.Replace(",", ",<br />");
                //output = output.Replace("{", "<br />{<br />");
                output = output.Replace("{", "&nbsp;&nbsp;&nbsp;{<br />");
                output = output.Replace("}", "<br />}");

            }
            catch (Exception ex)
            {
                output = ex.Message;

            }
            testo.Text = output;



        }

        protected void Button4_Click(object sender, EventArgs e)
        {
            testo.Text = "";
            string output = "";
            try
            {
                WSSEIMOK.rsReportManager dati = reportManagerWSM();
                output = JsonConvert.SerializeObject(dati.responseData);
                holdtext.Text = output;
                output = output.Replace(",", ",<br />");
                //output = output.Replace("{", "<br />{<br />");
                output = output.Replace("{", "&nbsp;&nbsp;&nbsp;{<br />");
                output = output.Replace("}", "<br />}");

            }
            catch (Exception ex)
            {
                output = ex.Message;

            }
            testo.Text = output;



        }

    
        private WSSEISVI.rsReportManager reportManagerWSS()
        {
            WSSEISVI.rqReportManager request = new WSSEISVI.rqReportManager
            {
                datiCliente = datiClienteS(),
                info = infoS(),
                requestData = requestDataS()
            };

            WSSEISVI.ReportManagerService s = new WSSEISVI.ReportManagerService();
           
            return s.reportManagerWS(request);
        }
        private WSSEISVI.uidConsulenza datiClienteS()
        {
            return new WSSEISVI.uidConsulenza
            {
                codiceAgente = codiceAgente.Text,
                codiceFiscale = codiceFiscale.Text,
                codiceMandato = codiceMandato.Text,
                codiceRete = codiceRete.Text
                };
        }
        private WSSEISVI.rqData requestDataS()
        {
            return new WSSEISVI.rqData
            {
                clientePB = false,
                clienteUnit = new WSSEISVI.rqClienteUnit
                {
                    anagraficaCliente = false
                },
                displayInfos = false,
                monitoraggioUnit = new WSSEISVI.rqMonitoraggioUnit
                {
                    monitoraggio = false
                },
                patrimonioUnit = new WSSEISVI.rqPatrimonioUnit
                {
                    contrattiCliente = false,
                    patrimonioAltro = false,
                    patrimonioAziendale = false,
                    patrimonioCasa = new WSSEISVI.rqPatrimonioCasa
                    {
                        assetClass = false,
                        categoria = false,
                        dettaglioProdotti = false,
                        distribuzioneEmittente = false,
                        distribuzioneRating = false,
                        distribuzioneScadenze = false,
                        distribuzioneTassoRendimento = false,
                        esposizioneValutaria = false,
                        esposizioneValutariaTutte = false,
                        macroAssetClass = false,
                        macroCategoria = false

                    },
                    patrimonioComplesivo = false,
                    patrimonioFinanziario = new WSSEISVI.rqPatrimonioFinanziario
                    {
                        assetClass = false,
                        categoria = false,
                        intermediario = false,
                        macroAssetClass = false,
                        macroCategoria = false
                    },
                    patrimonioImmobiliare = false,
                    patrimonioTerzi = new WSSEISVI.rqPatrimonioTerzi
                    {
                        assetClass = false,
                        categoria = false,
                        dettaglioProdotti = false,
                        intermediario = false,
                        macroAssetClass = false,
                        macroCategoria = false,
                        patrimonioTerziBean = false                        
                    }
                },
                pianificazioneUnit = new WSSEISVI.rqPianificazioneUnit
                {
                    pianificazioneOrizzontale = false,
                    pianificazioneVerticale = false
                },
                piramideModelloUnit = new WSSEISVI.rqPiramideModelloUnit
                {
                    piramideModello = false,
                    questionarioMifid = false
                },
                rischioUnit = new WSSEISVI.rqRischioUnit
                {
                    adeguatezza = false,
                    rischio = true
                }
            };
        }
        private WSSEISVI.rqInfo infoS()
        {
            return new WSSEISVI.rqInfo
            {
                 
            };
        }


        private WSSEICOLL.rsReportManager reportManagerWSC()
        {
            WSSEICOLL.rqReportManager request = new WSSEICOLL.rqReportManager
            {
                datiCliente = datiClienteC(),
                info = infoC(),
                requestData = requestDataC()
            };

            WSSEICOLL.ReportManagerService s = new WSSEICOLL.ReportManagerService();
            s.Url = "http://bfwspuc01c.fideuram.bancafideuram.it/fu-app/ReportManagerService?wsdl";
            return s.reportManagerWS(request);
        }
        private WSSEICOLL.uidConsulenza datiClienteC()
        {
            return new WSSEICOLL.uidConsulenza
            {
                codiceAgente = codiceAgente.Text,
                codiceFiscale = codiceFiscale.Text,
                codiceMandato = codiceMandato.Text,
                codiceRete = codiceRete.Text
            };
        }
        private WSSEICOLL.rqData requestDataC()
        {
            return new WSSEICOLL.rqData
            {
                clientePB = false,
                clienteUnit = new WSSEICOLL.rqClienteUnit
                {
                    anagraficaCliente = false
                },
                displayInfos = false,
                monitoraggioUnit = new WSSEICOLL.rqMonitoraggioUnit
                {
                    monitoraggio = false
                },
                patrimonioUnit = new WSSEICOLL.rqPatrimonioUnit
                {
                    contrattiCliente = false,
                    patrimonioAltro = false,
                    patrimonioAziendale = false,
                    patrimonioCasa = new WSSEICOLL.rqPatrimonioCasa
                    {
                        assetClass = false,
                        categoria = false,
                        dettaglioProdotti = false,
                        distribuzioneEmittente = false,
                        distribuzioneRating = false,
                        distribuzioneScadenze = false,
                        distribuzioneTassoRendimento = false,
                        esposizioneValutaria = false,
                        esposizioneValutariaTutte = false,
                        macroAssetClass = false,
                        macroCategoria = false

                    },
                    patrimonioComplesivo = false,
                    patrimonioFinanziario = new WSSEICOLL.rqPatrimonioFinanziario
                    {
                        assetClass = false,
                        categoria = false,
                        intermediario = false,
                        macroAssetClass = false,
                        macroCategoria = false
                    },
                    patrimonioImmobiliare = false,
                    patrimonioTerzi = new WSSEICOLL.rqPatrimonioTerzi
                    {
                        assetClass = false,
                        categoria = false,
                        dettaglioProdotti = false,
                        intermediario = false,
                        macroAssetClass = false,
                        macroCategoria = false,
                        patrimonioTerziBean = false
                    }
                },
                pianificazioneUnit = new WSSEICOLL.rqPianificazioneUnit
                {
                    pianificazioneOrizzontale = false,
                    pianificazioneVerticale = false
                },
                piramideModelloUnit = new WSSEICOLL.rqPiramideModelloUnit
                {
                    piramideModello = false,
                    questionarioMifid = false
                },
                rischioUnit = new WSSEICOLL.rqRischioUnit
                {
                    adeguatezza = false,
                    rischio = true
                }
            };
        }
        private WSSEICOLL.rqInfo infoC()
        {
            return new WSSEICOLL.rqInfo
            {

            };
        }


        private WSSEIPROD.rsReportManager reportManagerWSP()
        {
            WSSEIPROD.rqReportManager request = new WSSEIPROD.rqReportManager
            {
                datiCliente = datiClienteP(),
                info = infoP(),
                requestData = requestDataP()
            };

            WSSEIPROD.ReportManagerService s = new WSSEIPROD.ReportManagerService();
            s.Url = "http://bfwfpuc01.fideuram.bancafideuram.it/fu-app/ReportManagerService?wsdl";
            return s.reportManagerWS(request);
        }
        private WSSEIPROD.uidConsulenza datiClienteP()
        {
            return new WSSEIPROD.uidConsulenza
            {
                codiceAgente = codiceAgente.Text,
                codiceFiscale = codiceFiscale.Text,
                codiceMandato = codiceMandato.Text,
                codiceRete = codiceRete.Text
            };
        }
        private WSSEIPROD.rqData requestDataP()
        {
            return new WSSEIPROD.rqData
            {
                clientePB = false,
                clienteUnit = new WSSEIPROD.rqClienteUnit
                {
                    anagraficaCliente = false
                },
                displayInfos = false,
                monitoraggioUnit = new WSSEIPROD.rqMonitoraggioUnit
                {
                    monitoraggio = false
                },
                patrimonioUnit = new WSSEIPROD.rqPatrimonioUnit
                {
                    contrattiCliente = false,
                    patrimonioAltro = false,
                    patrimonioAziendale = false,
                    patrimonioCasa = new WSSEIPROD.rqPatrimonioCasa
                    {
                        assetClass = false,
                        categoria = false,
                        dettaglioProdotti = false,
                        distribuzioneEmittente = false,
                        distribuzioneRating = false,
                        distribuzioneScadenze = false,
                        distribuzioneTassoRendimento = false,
                        esposizioneValutaria = false,
                        esposizioneValutariaTutte = false,
                        macroAssetClass = false,
                        macroCategoria = false

                    },
                    patrimonioComplesivo = false,
                    patrimonioFinanziario = new WSSEIPROD.rqPatrimonioFinanziario
                    {
                        assetClass = false,
                        categoria = false,
                        intermediario = false,
                        macroAssetClass = false,
                        macroCategoria = false
                    },
                    patrimonioImmobiliare = false,
                    patrimonioTerzi = new WSSEIPROD.rqPatrimonioTerzi
                    {
                        assetClass = false,
                        categoria = false,
                        dettaglioProdotti = false,
                        intermediario = false,
                        macroAssetClass = false,
                        macroCategoria = false,
                        patrimonioTerziBean = false
                    }
                },
                pianificazioneUnit = new WSSEIPROD.rqPianificazioneUnit
                {
                    pianificazioneOrizzontale = false,
                    pianificazioneVerticale = false
                },
                piramideModelloUnit = new WSSEIPROD.rqPiramideModelloUnit
                {
                    piramideModello = false,
                    questionarioMifid = false
                },
                rischioUnit = new WSSEIPROD.rqRischioUnit
                {
                    adeguatezza = false,
                    rischio = true
                }
            };
        }
        private WSSEIPROD.rqInfo infoP()
        {
            return new WSSEIPROD.rqInfo
            {

            };
        }


        private WSSEIMOK.rsReportManager reportManagerWSM()
        {
            WSSEIMOK.rqReportManager request = new WSSEIMOK.rqReportManager
            {
                 
            };

            WSSEIMOK.ReportManagerService s = new WSSEIMOK.ReportManagerService();
            s.Url = "http://gendry.baratheon.hp:8081/?WSDL";
            return s.reportManagerWS(request);
        }
       
    }
}