﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.IO;
using System.Net;
using System.Threading;
using Consulenza.Web.ConsulenzaUnicaWS;
using System.Linq;
using Newtonsoft.Json;

namespace Consulenza.Web
{
    public partial class Nucleo : System.Web.UI.Page
    {
        private Dictionary<int, string> _elencoSezioni = new Dictionary<int, string>();
        public Dictionary<int, string> ElencoSezioni
        {
            get { return _elencoSezioni; }
            set { _elencoSezioni = value; }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                //caricaElencoSezioni();
            }
        }
        
        protected void Button1_Click(object sender, EventArgs e)
        {
            var reportManager = new ReportManager();

            var chiaveClientePb = tx_chiave.Text != "" ? int.Parse(tx_chiave.Text) : 0;

            #region Template costruito
          
            #endregion

            #region Template preso da DB
            //var template = new Template { IdModello = -1, Nome = "testNucleoSospeso" };// TextBox1.Text != "" ?  TextBox1.Text : "TestTemplate"}; 
            var template = new Template { IdModello =7, Nome = "TestTemplate(P1)" }; 
            #endregion

            // Il Falco
            //var imagePdf = reportManager.CreaReport("005933", "", "", "S", 50393, template, new ConsulenzaUnicaWS.Parametro[0]);

            // BARTOLOZZI - REGOLI
            //var imagePdf = reportManager.CreaReport("011523", "", "", "F", 27112, template, new ConsulenzaUnicaWS.Parametro[0]);


            // Nucleo Carlon
            // var imagePdf = reportManager.CreaReport("008500", "", "", "F", 60561, template, new ConsulenzaUnicaWS.Parametro[0]);

            // cc negativo altri Istituti
            //var imagePdf = reportManager.CreaReport("005199", "", "", "F", 50532, template, new ConsulenzaUnicaWS.Parametro[0]);

            // Operazioni in corso
            //var imagePdf = reportManager.CreaReport("000079", "", "", "F", 50520, template, new ConsulenzaUnicaWS.Parametro[0]);


            // Nucleo
            //var imagePdf = reportManager.CreaReport("012225", "", "", "F", 50452, template, new ConsulenzaUnicaWS.Parametro[0]);

            // Sguanci no altro
            //var imagePdf = reportManager.CreaReport("014407", "", "", "F", 50468, template, new ConsulenzaUnicaWS.Parametro[0]);

            //var imagePdf = reportManager.CreaReport("013489", "", "", "F", 32581, template, new ConsulenzaUnicaWS.Parametro[0]);

            #region Produzione
            var imagePdf = reportManager.CreaReport("015312", "DMECST71D10H501E", "", "F", 249716, template, new ConsulenzaUnicaWS.Parametro[0]);
            //var imagePdf = reportManager.CreaReport("006524", "", "", "F", 243582, template, new ConsulenzaUnicaWS.Parametro[0]);         
            #endregion

            if (imagePdf == null) return;

            Session["pdf"] = imagePdf;
            Response.Redirect("Report.aspx", false);
        }


      

    }
}
