﻿
namespace Consulenza.ReportCommon
{
    public enum TipologiaEsitoAdeguatezza
    {
        Adeguata,
        NonAdeguata
    }

    /// <summary>
    /// Rappresenta la Proposta oggetto del report richiesto.
    /// </summary>
    public class Proposta
    {
        
        /// <summary>
        /// Imposta o recupera la chiave delle Proposta
        /// </summary>
        public int Chiave { get; set; }
        public bool PropostaCBUnica { get; set; }
        /// <summary>
        /// Imposta o recupera la tipologia dello stato di adeguatezza della proposta
        /// </summary>
        public TipologiaEsitoAdeguatezza EsitoAdeguatezza { get; set; }
    }
}
