﻿using System.Collections.Generic;
using Consulenza.ReportWriter.Business.Entity;
using ceTe.DynamicPDF;

namespace Consulenza.ReportWriter.Business.OBJ_PDF
{
    /// <summary>
    /// Rappresenta un oggetto contenitore di Elements che saranno disegnati su ciascuna pagina in caso di salto pagina della Entity di riferimento.
    /// </summary>
    public class RepeaterPDF : ObjectPDF
    {
        public List<ObjectPDF> Elements { get; set; }

        public RepeaterPDF(List<ObjectPDF> elements)
        {
            Elements = elements;
            ObjectType = ObjectTypePdf.REPEATER;
        }

        /// <summary>
        /// Ritorna l'oggetto che sarà stampato sulla pagina del documento.
        /// </summary>
        /// <returns></returns>
        public override PageElement ToElement()
        {
            return null;
        }
    }
}
